﻿using System;
using System.ComponentModel;
using System.Threading;
using Wisej.Web;

namespace Wisej.DGVTimerUpdates
{
    // you don't need this class. it's here just to
    // call LoadData in OnWebDataRead, which is the parallel call.
    public class MyDataGridView : DataGridView
    {
        protected override object OnWebDataRead(int firstIndex, int lastIndex, ListSortDirection sortDirection, int sortIndex)
        {
            LoadData();

            return base.OnWebDataRead(firstIndex, lastIndex, sortDirection, sortIndex);
        }

        // simulate a concurrent call.
        public void LoadData()
        {
            lock (syncLock) // comment out to cause the problem.
            {
                // you can remove inRefreshData when using the lock block.
                if (inRefreshData)
                    throw new Exception("Parallel request!");

                inRefreshData = true;
                try
                {
                    var grid = this;
                    var random = new Random();

                    grid.RowCount = random.Next(10, 50);
                    for (var i = 0; i < grid.RowCount; i++)
                    {
                        // simulate db work.

                        Thread.Sleep(10);
                        grid[0, i].Value = random.Next(0, 10000).ToString();
                        grid[1, i].Value = random.Next(0, 10000).ToString();
                    }
                }
                finally
                {
                    inRefreshData = false;
                }
            }
        }
        bool inRefreshData = false; // to remove
        object syncLock = new object();
    }
}